# Ressources

Vous trouverez ci-dessous une collection incomplète de nombreuses ressources pour apprendre et appliquer XState dans des applications du monde réel. Découvrez la collection [Awesome XState](https://github.com/darrylhebbes/awesome_xstate) sur GitHub pour encore plus de ressources !

![Stately member](/docs/stately.png) - Ressource d'un membre de la communauté Stately

## Cours

:::tip Cours officiel
Regardez le cours officiel [State Machines in JavaScript with XState](https://frontendmasters.com/courses/xstate/) par [@davidkpiano](https://twitter.com/davidkpiano) sur Frontend Masters ! Dans ce cours, vous apprendrez les bases des machines d'état et des diagrammes d'état, de la création de votre propre sans aucune bibliothèque en JavaScript pur, jusqu'à l'utilisation de XState pour tirer parti d'une grande variété de fonctionnalités.

Les exemples de code de l'atelier sont [open-source et disponibles sur GitHub](https://github.com/statelyai/frontend-masters-xstate-workshop).

Il existe également un cours de suivi : [State Modeling with React and XState](https://frontendmasters.com/workshops/xstate-react/). Une fois que vous avez suivi le premier cours, assurez-vous de suivre celui-ci également afin d'apprendre à appliquer des machines d'état et des diagrammes d'états aux applications du monde réel et à maîtriser des concepts avancés tels que la génération/appel d'acteurs et les tests basés sur des modèles.
:::

:::tip Catalogue
Explorez une collection de machines d'état et de diagrammes d'état conçus par des professionnels dans le [Catalogue XState](https://xstate-catalogue.com/). Vous pouvez copier-coller ces machines directement dans vos projets, ainsi que les visualiser directement dans le catalogue.
:::

**Autres excellents cours et guides :**

- [Egghead - Introduction to State Machines Using XState](https://egghead.io/courses/introduction-to-state-machines-using-xstate) par [Kyle Shevlin](https://twitter.com/kyleshevlin)
  - [GitHub - Course Notes](https://github.com/eggheadio-projects/introduction-to-state-machines-using-xstate-notes)
  - [GitHub - Workshop](https://github.com/kyleshevlin/intro-to-state-machines-and-xstate-workshop)
- [Egghead - Construct Sturdy UIs with XState](https://egghead.io/courses/construct-sturdy-uis-with-xstate) par [Isaac Mann](https://twitter.com/MannIsaac)
- [XState Guide](https://examples.bradwoods.io/xstate) par [Brad Woods](https://twitter.com/bradwoodsio)
- [DevTrends: XState](https://devtrends.io/videos/xstate/) par [Anthony Gore](https://twitter.com/anthonygore)

## Podcasts

- [Q&A on XState, Getting Comfortable with JavaScript, Managing WordPress Sites, and Background Images in CSS](https://shoptalkshow.com/483/#t=01:18) le 04/10/2021
- [🎙 (Modern Web) S07E20: Building State Machines using XState with David Khourshid](https://modernweb.podbean.com/e/s07e20-modern-web-podcast-building-state-machines-using-xstate-with-david-khourshid/) le 20/01/2021 ![Stately member](/docs/stately.png)
  - [▶️ Video](https://www.youtube.com/watch?v=uLlQjp5u2KQ)
- [🎙 (React Podcast) 83: David Khourshid on XState, Statecharts, and the Future of Designer—Coder Collaboration](https://reactpodcast.com/episodes/83) le 27/02/2020 ![Stately member](/docs/stately.png)
- [🎙 (Syntax.FM) 206: State Machines, CSS and Animations with David K Piano](https://syntax.fm/show/206/state-machines-css-and-animations-with-david-k-piano) le 18/12/2019 ![Stately member](/docs/stately.png)
- [🎙 (Egghead.io Podcast) 11: Introduction To State Machines And XState With Kyle Shevlin](https://egghead.io/podcasts/introduction-to-state-machines-and-xstate-with-kyle-shevlin) le 17/12/2019
- [🎙 (Full Stack Radio) 130: David Khourshid - Building Better UI Components with State Machines](https://fullstackradio.com/130) le 11/12/2019 ![Stately member](/docs/stately.png)
- [🎙 (Chats with Kent) Make Your Apps Resilient Using Finite State Machines With David Khourshid](https://kentcdodds.com/chats-with-kent-podcast/seasons/01/episodes/make-your-apps-resilient-finite-state-machines-with-david-khourshid) le 05/08/2019 ![Stately member](/docs/stately.png)
- [🎙 (React Round-Up) 069: The State Machines in React with David Khourshid](https://devchat.tv/react-round-up/rru-069-the-state-machines-in-react-with-david-khourshid/) le 09/07/2019 ![Stately member](/docs/stately.png)
- [🎙 (ShopTalk Show) 327: Working with State Machines with Jon Bellah and David Khourshid](https://shoptalkshow.com/327-working-state-machines/) le 03/09/2018 ![Stately member](/docs/stately.png)
- [🎙 (React Podcast) 5: Finite State Machines with David Khourshid](https://reactpodcast.com/episodes/5) le 03/04/2018 ![Stately member](/docs/stately.png)

## Articles

- [Using State Machines in Front-End Development](https://blog.picnic.nl/using-state-machines-in-front-end-development-c875ea1d5322) par [Danielle Richter](https://medium.com/@danielle.richter) 27/10/2021
- [Quick post: Modeling a video player with XState](https://dev.to/matiasfha/quick-post-modeling-a-video-player-with-xstate-eko) par [Matías Hernández Arellano](https://twitter.com/cafe_contech) le 25/10/2021
- [Getting Started with XState, React and Typescript (Part 2)](https://moduscreate.com/blog/getting-started-with-xstate-react-and-typescript-part-2/) par [Santiago Kent](https://twitter.com/moduscreate) le 18/10/2021
- [Untangling your Logic using State Machines](https://blog.robruizr.dev/untangling-your-logic-using-state-machines) par [Roberto Ruiz](https://twitter.com/robruizrdevs) le 07/10/2021
- [The power of XState](https://dev.to/manoryanir/the-power-of-x-state-1npg) par [Yanir Manor](https://dev.to/manoryanir) le 04/10/2021
- [Building an acquisition Funnel in React with Xstate - Part 1](https://dev.indooroutdoor.io/building-an-acquisition-funnel-in-react-with-xstate) par [Jb Rocher](https://hashnode.com/@Araelath)
- [XState - Expero Night](https://slides.com/ivanbtrujillo/deck) par Iván Trujillo
- [Orchestrating Serverless from Serverless](https://medium.com/@kjartanmuller/orchestrating-serverless-from-serverless-bcdb751ddd6c) par [Kjartan Rekdal Müller](https://medium.com/@kjartanmuller) le 20/09/2021
- [How to model application flows in React with finite state machines and XState](https://engineering.kablamo.com.au/posts/2021/finite-state-machines-and-xstate) par [Andrew McDowell](https://twitter.com/madole) le 23/07/2021
- [Testing XState machines in your React Native app](https://medium.com/welld-tech/testing-xstate-machines-in-your-react-native-app-236fb01bf5b8) par [Simone D'Avico](https://sdavico.medium.com/) le 15/07/2021
- [Using XState with Deno](https://gustavosantos.dev/a/using-xstate-with-deno) par [Bruno Quaresma](https://twitter.com/bruno__quaresma) le 24/06/2021
- [Use an XState Machine with React](https://dev.to/jbranchaud/use-an-xstate-machine-with-react-326i) par [Josh Branchaud](https://twitter.com/jbrancha) le 09/05/2021
- [XState: Should this be an action, or a service?](https://dev.to/mpocock1/xstate-should-this-be-an-action-or-a-service-2cp0) par [Matt Pocock](https://twitter.com/mpocock1) le 30/04/2021 ![Stately member](/docs/stately.png)
- [State Machines: Should this be a state, or in context?](https://dev.to/mpocock1/state-machines-should-this-be-a-state-or-in-context-1d7e) par [Matt Pocock](https://twitter.com/mpocock1) le 29/04/2021 ![Stately member](/docs/stately.png)
- [XState: What's the difference between Machine and createMachine?](https://dev.to/mpocock1/xstate-what-s-the-difference-between-machine-and-createmachine-15h1) par [Matt Pocock](https://twitter.com/mpocock1) le 28/04/2021 ![Stately member](/docs/stately.png)
- [How to Use Finite State Machines in React](https://www.telerik.com/blogs/how-to-use-finite-state-machines-react) par [Leonardo Maldonado](https://www.telerik.com/blogs/author/leonardo-maldonado) le 17/03/2021
- [Frontend is Rocket Science – Managing state in any JavaScript Application](https://blog.oddeven.ch/blog/frontend-is-rocket-science-managing-state-in-any-javascript-application/) par [Aleksej Dix](https://twitter.com/aleksejdix) le 26/02/2021
- [Boost your React application's performance by XState](https://dev.to/alirezavalizade/boost-your-react-application-s-performance-by-xstate-42p8) par [Alireza Valizade](https://dev.to/alirezavalizade) le 24/02/2021
- [Rsvp to weddings with XState](https://dev.to/droopytersen/rsvp-to-weddings-with-xstate-55nl) par [Andrew Peterson](https://dev.to/droopytersen) le 19/02/2021
- [An Introduction to XState in TypeScript](https://medium.com/giant-machines/an-introduction-to-xstate-in-typescript-e71c7729ce88) par [Neeraj Khosla](https://medium.com/@n.khosla91) le 04/02/2021
- [An Introduction to Finite State Machines: Simplifying React State Management with State Machines](https://soshace.com/an-introduction-to-finite-state-machines-simplifying-react-state-management-with-state-machines/) par [Bradley Kofi](https://soshace.com/author/bradstarart/) le 02/02/2021
- [Integrate XState with React Native and React Navigation](https://medium.com/welld-tech/integrate-xstate-with-react-native-and-react-navigation-21ead87391da) par [Simone D'Avico](https://sdavico.medium.com/) le 02/02/2021
- [Infinite Scrolling with Svelte 3, XState and IntersectionObserver](https://dev.to/gcdcoder/infinite-scrolling-with-svelte-3-xstate-and-intersectionobserver-127j) par [Gustavo Castillo](https://dev.to/gcdcoder) le 01/02/2021
- [Untangle complex flows in your React Native app with XState](https://medium.com/welld-tech/untangle-complex-flows-in-your-react-native-app-with-xstate-1b11d0b8a91f) par [Simone D'Avico](https://sdavico.medium.com/) le 14/01/2021
- ["Just Use Props": An opinionated guide to React and XState](https://dev.to/mpocock1/just-use-props-an-opinionated-guide-to-react-and-xstate-fc9) par [Matt Pocock](https://dev.to/mpocock1) le 11/01/2021 ![Stately member](/docs/stately.png)
- [Creating State Machines in JavaScript with XState](https://nisimdor.medium.com/creating-state-machines-in-javascript-with-xstate-21e1599521be) par [Dor Nisim](https://nisimdor.medium.com/) le 10/01/2021
- [Future of state management in React with XState](https://blog.jskoneczny.pl/post/future-of-state-management-in-react-with-xstate) par [Jakub Skoneczny](https://blog.jskoneczny.pl/) le 05/01/2021
- [Learning XState by refactoring an old project](https://fvsch.com/learning-xstate) par [Florens Verschelde](https://fvsch.com/) le 01/01/2021
- [React context without context, using XState – CodeWithSwiz 14, 15](https://swizec.com/blog/react-context-without-context-using-xstate-codewithswiz-14-15) par [@swizec](https://swizec.com) le 10/11/2020
- [State Machines Workshop with XState](https://github.com/ooade/state-machines-workshop) par [Ademola (@ooade)](https://github.com/ooade) le 06/11/2020
- [Tes en Línea: React, TypeScript, XState, fp-ts & CSS Grid (esp)](https://medium.com/codingedgar/tes-en-l%C3%ADnea-react-typescript-xstate-fp-ts-css-grid-esp-1373236189d1) par [Edgar Rodriguez](https://medium.com/@codingedgar) le 29/10/2020
- [How to write tests for XState](https://swizec.com/blog/how-to-write-tests-for-xstate-codewithswiz-12/) par [@swizec](https://swizec.com) on 2020-10-13
- [Create-React-App Template with XState](https://github.com/kwdowik/cra-template-xstate) par [Kacper Wdowik](https://github.com/kwdowik) le 18/10/2020
- [XState Brain Teaser #1 - Auth Flow](https://dev.to/mpocock1/xstate-brain-teaser-1-auth-flow-2jhl) par [Matt Pocock](https://twitter.com/mpocock1) le 09/10/2020 ![Stately member](/docs/stately.png)
- [Refactoring a useReducer to XState, Part 1](https://swizec.com/blog/refactoring-a-usereducer-to-xstate-pt1-codewithswiz-11/) par [@swizec](https://swizec.com) le 08/10/2020
- [How State Machines Saved Our Bacon 🥓](https://www.ianjones.us/xstate-saves-our-bacon) par [Ian Jones](https://www.ianjones.us/) le 01/10/2020 (approximatif)
- [Finite State Machines in React JS using XState JS](https://dev.to/soorajsnblaze333/finite-state-machines-in-react-js-using-xstate-36ho) par [Sooraj](https://dev.to/soorajsnblaze333) le 23/09/2020
  - [CodeSandbox example](https://codesandbox.io/s/small-sea-t5mce?file=/pages/index.js/)
- [My First Machine, Getting Started with XState and Angular](https://calebukle.com/blog/my-first-machine-getting-started-with-xstate-and-angular) par [Caleb Ukle](https://calebukle.com) le 11/09/2020
- [State Machines For Everyone](https://medium.com/well-red/state-machines-for-everyone-part-1-introduction-b7ac9aaf482e) par [Alex Dodge](https://medium.com/@alexmdodge) le 08/09/2020
- [State machines in Production](https://moduscreate.com/blog/state-machines-in-production/) par [Ivan Kovic](https://twitter.com/kobeljic) le 02/09/2020
- [Testing XState with React Testing Library](https://dev.to/joepurnell1/testing-xstate-with-react-testing-library-26kh) par [Joe Purnell](https://dev.to/joepurnell1) le 27/08/2020
- [When your brain is breaking, try XState](https://swizec.com/blog/when-your-brain-is-breaking-try-xstate) par [@swizec](https://swizec.com) le 10/08/2020
- [Todo App with XState and Vue composition API](https://dev.to/jasmin/todo-app-with-xstate-and-vue-composition-api-52ae) par [Jasmin Virdi](https://dev.to/jasmin) le 03/08/2020
- [Firebase authentication with XState and Svelte](https://codechips.me/firebase-authentication-with-xstate-and-svelte/) par [@codechips](https://github.com/codechips) le 31/07/2020
- [SWR-Style Fetching with XState State Machines](https://imfeld.dev/writing/swr_with_xstate) par [Daniel Imfeld](https://imfeld.dev) le 21/07/2020
- [Hello XState Part 3: Writing my first state machines (and washing my hands)](https://dev.to/ekafyi/hello-xstate-part-3-writing-my-first-state-machines-and-washing-my-hands-for-20-seconds-23p) par [Eka](https://dev.to/ekafyi) le 21/07/2020
- [Intro: XState and State Machines (React)](https://medium.com/@d_danailov/intro-sstate-and-state-machines-react-3b873a6a713d) par [Dimitar Danailov](https://medium.com/@d_danailov) le 17/07/2020
- [XState, React, and TypeScript - how to get it working](https://dev.to/mpocock1/xstate-react-and-typescript-how-to-get-it-working-4p18) par [Matt Pocock](https://dev.to/mpocock1) le 17/07/2020 ![Stately member](/docs/stately.png)
- [Slides - Working with State Machines in Angular](https://slides.com/stli/xstate-angular-nl) avec XState par [Stefanos Lignos](https://twitter.com/stefanos_lig) le 20/07/2020
- [Hello XState Part 2: Exploring the XState Viz example](https://dev.to/ekafyi/hello-xstate-part-2-exploring-the-xstate-viz-example-1nc1) par [Eka](https://dev.to/ekafyi) le 13/07/2020
  - [GitHub - code](https://github.com/codechips/svelte-firebase-auth-xstate-example)
- [Hello XState Part 1: Learning state machines for frontend web development](https://dev.to/ekafyi/hello-xstate-learning-state-machines-for-frontend-web-development-5bin) par [Eka](https://dev.to/ekafyi) le 12/07/2020
- [Comparing state machines: XState vs. Robot](https://blog.logrocket.com/comparing-state-machines-xstate-vs-robot/) par [Samaila Bala](https://blog.logrocket.com/author/samailabala/) le 09/07/2020
- [Starting with State Machines and XState!](https://dev.to/jasmin/starting-with-state-machine-and-xstate-1972) par [Jasmin Virdi](https://dev.to/jasmin) le 06/07/2020
- [Learn and Apply XState with Vonage Video](https://dev.to/vonagedev/learn-and-apply-xstate-with-vonage-video-5dfg) par [Kelly Andrews](https://dev.to/kellyjandrews) le 01/07/2020
  - [Article on Nexmo.com](https://www.nexmo.com/blog/2020/07/01/learn-and-apply-xstate-with-vonage-video)
- [Introduction to XState](https://flaviocopes.com/xstate/) par [Flavio Copes](https://flaviocopes.com/) le 26/06/2020
- [Multistep form handling with Finite State Machines, Formik and TypeScript](https://thewidlarzgroup.com/multistep-form-xstate-formik/) par Daniel Grychtoł le 17/06/2020
- [Intro to XState - a true state management library for React](https://medium.com/@pavlo_lompas/intro-to-xstate-a-true-state-management-system-library-for-react-d8c0051c71e4) par [Pavlo Lompas](https://medium.com/@pavlo_lompas) le 15/06/2020
- [Remake of the 100 squares game](https://onehundred.now.sh/) par [@nikpundik](https://twitter.com/nikpundik) le 05/06/2020
  - [Tweet with demo](https://twitter.com/nikpundik/status/1268936078737670145)
- [ThoughtWorks - XState in the Technology Radar for Languages & Frameworks](https://www.thoughtworks.com/radar/languages-and-frameworks/xstate) le 19/05/2020
- [A front-end journey into XState](https://medium.com/@roberthigdon/a-front-end-journey-into-xstate-d13691b9165d) par [Robert Higdon](https://medium.com/@roberthigdon) le 15/05/2020
- [GitHub - Stripe Machine Example](https://github.com/JacobParis/stripe-machine-example): An animated stripe checkout using XState and React by [@JacobParis](https://github.com/JacobParis) le 08/05/2020
- [XState and Svelte: initial setup](https://geoexamples.com/svelte/2020/05/08/xstate-svelte-I.html) par [@rveciana](https://github.com/rveciana) le 08/05/2020
- [How To Build Finite State Machines using XState and React](https://www.ibrahima-ndaw.com/blog/xstate-react-finite-state-machine/) par [Ibrahima Ndaw](https://www.ibrahima-ndaw.com) le 21/04/2020
  - [Post on Dev.to](https://dev.to/ibrahima92/how-to-build-finite-state-machines-using-xstate-and-react-1o8g)
- [XState Minesweeper](https://github.com/lednhatkhanh/xstate-minesweeper) par [@lednhatkhanh](https://github.com/lednhatkhanh/xstate-minesweeper) le 16/04/2020
  - [Playable demo](https://xstate-minesweeper.now.sh/)
- [XState Chart Traffic Lights](https://github.com/howardmann/xstate/tree/master/traffic-light) par [@howardmann](https://github.com/howardmann) le 16/04/2020
  - [Demo link](http://xstatetrafficlight.surge.sh/)
  - [XState visualization](https://stately.ai/viz?gist=1b9e1bcf75b1fed19190adc9f39b895e)
- [A simple calculator using React and XState (statecharts)](https://github.com/diegoperezm/react-xstate-calc) par [diegoperezm](https://github.com/diegoperezm) le 15/04/2020
- [Modeling parallel states in XState](https://dev.to/jacobmparis/modelling-parallel-states-in-xstate-3pe0) par [Jacob Paris](https://dev.to/jacobmparis) le 05/04/2020
  - [XState Text Formatting Part 2](https://dev.to/jacobmparis/xstate-text-formatting-part-2-32ma)
- [Guidelines for State Machines and XState](https://kyleshevlin.com/guidelines-for-state-machines-and-xstate/) par [Kyle Shevlin](https://kyleshevlin.com) le 03/04/2020
- [An Introduction to State Machines using XState](https://keyholesoftware.com/2020/03/30/an-introduction-to-state-machines-using-xstate/) par [Mat Warger](https://keyholesoftware.com/author/mwarger/) le 30/03/2020
  - [GitHub Demo](https://github.com/in-the-keyhole/xstate-demo)
- [React Single File Components with XState](https://dev.to/robertbroersma/react-single-file-components-with-xstate-19k4) par [Robert](https://dev.to/robertbroersma) le 29/03/2020
- [State-driven interfaces with XState](https://blog.logrocket.com/state-driven-interfaces-with-xstate/) par [Brad Woods](https://blog.logrocket.com/author/bradwoods/) le 23/03/2020
- [Undo/Redo in React Using XState](https://dev.to/robertbroersma/undo-redo-in-react-using-xstate-23j8) par [Robert](https://dev.to/robertbroersma) le 22/03/2020
  - [CodeSandbox demo](https://codesandbox.io/s/xstate-undo-redo-i3eiu)
- [Working with non-user asynchronous events in model based tests with XState](https://dev.to/rjdestigter/working-with-non-user-asynchronous-events-in-model-based-tests-with-xstate-58ek) par [John de Stigter](https://dev.to/rjdestigter) le 18/03/2020
- [Supervising XState Machines with Redux](https://dev.to/rjdestigter/supervising-xstate-machines-with-redux-277d) par [John de Stigter](https://dev.to/rjdestigter) le 16/03/2020
- [Model based UI tests with XState, Cypress, Puppeteer & more](https://dev.to/rjdestigter/model-based-ui-tests-with-xstate-cypress-puppeteer-more-268d) par [John de Stigter](https://dev.to/rjdestigter) le 12/03/2020
- [Thoughts on State Management with XState and ReactJS](https://dev.to/rjdestigter/thoughts-on-state-management-with-xstate-and-reactjs-3d19) par [John de Stigter](https://dev.to/rjdestigter) le 08/03/2020
- [XState: The new opportunity for web development](https://medium.com/yakindu/statecharts-a-new-path-for-the-future-of-web-development-9c8a8fb85717) par [@mschulte](https://medium.com/@mschulte_69595) le 05/03/2020
- [Communicating with spawned and invoked XState actors in React](https://itnext.io/communicating-with-spawned-and-invoked-xstate-actors-in-react-999cca56506b) par Ismayil Khayredinov le 02/02/2020
- [Replacing Vuex with XState](https://dev.to/felix/replacing-vuex-with-xstate-3097) par [Felix Guerin](https://dev.to/felix) le 28/01/2020
- [XState 状态管理](https://blog.zfanw.com/xstate-state-management/) par 陈三 le 31/12/2019
- [XState 新手教學 - Finite State Machine](https://blog.jerry-hong.com/posts/xstate-tutorials-state-machine/?fbclid=IwAR14AL6nwxR5lb78CSABY18rOm2EA7I5f7uaErgZGC0ISmcJFri0VL91_xA) par Jerry Hong le 08/12/2019
- [How to Effortlessly Model Async (React) with XState's Invoke](https://medium.com/@tahini/how-to-effortlessly-model-async-react-with-xstates-invoke-4c36dc8547b3) par Matthew Jones le 30/10/2019
- [Getting Started with XState](https://www.vietnguyen.site/getting-started-with-xstate/) par Viet Nguyen le 09/10/2019
- [A series of examples showing how to model application state with statechart using xstate](https://github.com/coodoo/xstate-examples) par [@coodoo](https://github.com/coodoo/xstate-examples) le 27/09/2019
- [Finite State Machines in React JS using XState](https://www.skcript.com/svr/finite-state-machines-in-react-js-using-xstate/) par [Sooraj Nair](https://www.linkedin.com/in/sooraj-nair-a81543172/) LE 22/08/2019
- [Hyperapp demo with XState](https://github.com/johnkazer/hyperapp-xstate-demo) par [@johnkazer](https://github.com/johnkazer) LE 23/07/2019
- [My love letter to XState and statecharts ♥](https://dev.to/timdeschryver/my-love-letter-to-xstate-and-statecharts-287b) par Tim Deschryver le 08/07/2019
- [Creating a Complex IVR System with Ease with XState](https://www.nexmo.com/blog/2019/06/20/creating-a-complex-ivr-system-with-ease-with-xstate-dr) par Yonatan Mevorach le 20/06/2019
- [StackOverflow: What is an actual difference between redux and a state machine (e.g. xstate)?](https://stackoverflow.com/questions/54482695/what-is-an-actual-difference-between-redux-and-a-state-machine-e-g-xstate/54521035#54521035) par [David Khourshid](https://github.com/statelyai) le 04/02/2019 ![Stately member](/docs/stately.png)
- [XState - a TypeScript state machine with a lot of features](http://realfiction.net/2019/01/30/xstate-a-typescript-state-machine-with-a-lot-of-features) par Frank Quednau le 30/01/2019
- [Vuex + XState](https://medium.com/@brockreece/vuex-xstate-4f9ea23bb24e) par [Brock Reece](https://medium.com/@brockreece) le 17/09/2017

## Videos

- [▶️ Design a polling state machine with XState](https://www.youtube.com/watch?v=DMXAv8iTrcY) par [Josh Branchaud](https://twitter.com/jbrancha)
- [▶️ You're a Wizard Form, Harry (Infobip Shift)](https://www.youtube.com/watch?v=0bY9_DasGEg) par [Erik Rasmussen](https://github.com/erikras) le 08/09/2021
- [▶️ Making Application Logic Visually Collaborative (Infobip Shift)](https://www.youtube.com/watch?v=ubFj_QfNCL8) par [David Khourshid](https://github.com/statelyai) le 07/09/2021 ![Stately member](/docs/stately.png)
- [▶️ The Actor Model: a new mental model for React (React Finland)](https://www.youtube.com/watch?v=9k1ZHHJWt7k) par [Farzad Yousefzadeh](https://github.com/farskid) le 01/09/2021 ![Stately member](/docs/stately.png)
- [▶️ Make legacy code delightful with statecharts (React Finland)](https://www.youtube.com/watch?v=zll9uDQOOq0) par [Matt Pocock](https://twitter.com/mpocock1) le 01/09/2021 ![Stately member](/docs/stately.png)
- [▶️ Introducing state machines and statecharts (React Finland)](https://www.youtube.com/watch?v=Y_lOg-rsqBM) par [Laura Kalbag](https://github.com/LauraKalbag) le 01/09/2021 ![Stately member](/docs/stately.png)
- [▶️ The State of XState (React Finland)](https://www.youtube.com/watch?v=Q05jcu9N98g) le 30/08/2021 par [David Khourshid](https://github.com/statelyai) ![Stately member](/docs/stately.png)
- [▶️ Splitting the view and the brains in JS — state machines with XState (in French)](https://www.youtube.com/watch?v=yRB57CDvQuY) par [Aurelien Meunier](https://www.linkedin.com/in/aumeunier) le 22/06/2021
- [▶️ Front-end state management with XState](https://www.youtube.com/watch?v=Slb6M_rIn0M) par [Amy Pellegrini](https://twitter.com/amyvpellegrini) le 09/06/2021
- [▶️ Maquinas de estado finito y gráficas de estado en React ](https://www.youtube.com/watch?v=Rm6AMY6-Wqw) par José L Narajo le 19/03/2021
- [▶️ Use State Machines to Build a Queue for Custom Twitch Overlays — Learn With Jason](https://www.youtube.com/watch?v=UzA5Mvk587M) par [Jason Lengstorf](https://www.youtube.com/channel/UCnty0z0pNRDgnuoirYXnC5A) le 26/02/2021
- [▶️ Getting Started with XState, React, and Typescript | Part 1](https://www.youtube.com/watch?v=po1YRAk7irY) par [Modus Create](https://www.youtube.com/channel/UCsKwL0-e2eHRNa6Ne99AESw) le 18/02/2021
- [▶️ Modelling application behaviour with the XState library (in React)](https://www.youtube.com/watch?v=paZ4ImyI1YQ) par [Marc Klefter](https://twitter.com/marcklefter) le 11/02/2021
- [▶️ Custom Svelte Store: XState as Svelte store](https://www.youtube.com/watch?v=NIfQsc5XAzU) par [lihautan](https://www.youtube.com/channel/UCbmC3HP3FaAFdcZkui8YoMQ) le 10/02/2021
- [▶️ XState Introduction](https://www.youtube.com/watch?v=clu2bqjk3c0) on [For Those Who Code](https://www.youtube.com/channel/UCS3-MF_4ADqglU2OSly4vIw) le 08/02/2021
- [▶️ XState - Global state in React](https://www.youtube.com/watch?v=1kJcnFBrk2I) par [Matt Pocock](https://twitter.com/mpocock1) le 04/02/2021 ![Stately member](/docs/stately.png)
- [▶️ Finite State Machine on Frontend](https://www.youtube.com/watch?v=gCT-lCYYhf4) par [Eugenia Zigisova](https://twitter.com/jevgeniazi) le 20/01/2021
- [▶️ Typing XState in Vue 3](https://www.youtube.com/watch?v=7tT45eRmyJE) par [JacoboCode](https://www.youtube.com/channel/UCcE2YngHoargpdjIzkCNY2Q) le 18/01/2021
- [▶️ Infinite Scrolling con Svelte, IntersectionObserver & XState (en español)](https://www.youtube.com/watch?v=GMXrwrG0cL4) par [GCD Coder](https://www.youtube.com/channel/UCwkisgTJdCx3mNZMaaHAaVA) le 13/01/2021
- [▶️ Getting Started with XState in Vue 3](https://www.youtube.com/watch?v=g4YnmydXMP8) par [JacoboCode](https://www.youtube.com/channel/UCcE2YngHoargpdjIzkCNY2Q) le 05/01/2021
- [▶️ Usando XState y React para hacer peticiones HTTP (en español)](https://www.youtube.com/watch?v=Wo-rVyAsz-Q) par [GCD Coder](https://www.youtube.com/channel/UCwkisgTJdCx3mNZMaaHAaVA) le 29/12/2020
- [▶️ Modeling a Voicemail Widget with XState](https://www.youtube.com/watch?v=D6LzWcV_-14) par [Constantin Druc](https://www.youtube.com/channel/UCsMdRMBnxIVO0K_YS0KHiMA) le 20/12/2020
- [▶️ React Wednesdays: XState and JavaScript State Machines](https://www.youtube.com/watch?v=1TT2ymkYGyM) le 09/12/2020
- [▶️ Frontend is Rocket Science - How to use XState in Vue 3 Now!](https://www.youtube.com/watch?v=wRktleOGKS4) par [Aleksej Dix](https://twitter.com/aleksejdix) le 06/11/2020
- [▶️ Finite State Machines in Vue 3](https://www.youtube.com/watch?v=fT9p9CCSrn8) par [Sarah Dayan](https://twitter.com/frontstuff_io) le 06/11/2020
- [▶️ Tutorial of C++ Code Generator for XState State Machine engine](https://www.youtube.com/watch?v=DnuJFUR1SgA) par [Andrew Shuvalov](https://www.youtube.com/channel/UCHFfZT1QM-vnqSZKtrT0e6g) le 30/10/2020
  - [▶️ Part 2](https://www.youtube.com/watch?v=8TTfRrmNu0s)
  - [▶️ Part 3](https://www.youtube.com/watch?v=HoH68709Sq8)
  - [GitHub Project](https://github.com/shuvalov-mdb/xstate-cpp-generator)
- [▶️ XState and React](https://www.youtube.com/watch?v=pclR8Q5mbNI) on [Leniolabs](https://www.youtube.com/channel/UCcRg2Au0LLtEcakG9fg6VXg) le 08/10/2020
- [▶️ XState and State Machines in VueJS](https://www.youtube.com/watch?v=8y9wUwJvdGs) par [Constantin Druc](https://www.youtube.com/channel/UCsMdRMBnxIVO0K_YS0KHiMA) le 30/09/2020
- [▶️ Reducing state complexity with XState](https://www.youtube.com/watch?v=CpxL-4oIZPw) par [Kishore](www.github.com/pkishoez) le 21/09/2020
- [▶️ Refactoring with XState - Part 1](https://www.youtube.com/watch?v=hZ1vaMJnKx0) par [VigsCodes](https://www.youtube.com/channel/UCAFlrYILud3-3MCs8nsDiAA) le 06/09/2020
- [▶️ State-driven Interfaces with XState](https://www.youtube.com/watch?v=bPUgBHFfQdI) on [Mozilla Indonesia](https://www.youtube.com/channel/UCUwngm8TCj0mhsvKTO2q5fQ) le 30/08/2020
- [▶️ Easy Introduction to XState in React | States, Transitions, Guards, and (Actions](https://www.youtube.com/watch?v=PRwDOSjIFg8) par [Bhargav Ponnapalli](https://www.youtube.com/channel/UC4gKWR53xDzybMwm8Y61ukA) le 28/08/2020
- [▶️ Virtual Lunch & Learn: Let's build an app using Svelte, TypeScript, XState and Tailwind](https://www.youtube.com/watch?v=-FiN2Svpk2s) par Anders Bech Mellson le 26/08/2020
- [▶️ Mini Introducción a XState](https://www.youtube.com/watch?v=brMpOOAOUZ4) par [Michell Ayala](https://www.youtube.com/channel/UCBXo5FFDCtNoddUOqZuWX7w) 14/08/2020
  - [▶️ React + XState](https://www.youtube.com/watch?v=Z7LIsZfQ4LU)
- [▶️ Model Based Testing with XState | Why It's Great | Part 1](https://www.youtube.com/watch?v=tkxH7o-n9sI) par [John Bales](https://www.youtube.com/channel/UCVYw7ad200ZmvsZ0BVC9YvA) le 11/08/2020
  - [▶️ Model Based Testing with XState | The Basics | Part 2](https://www.youtube.com/watch?v=9_dWCweA8Pk)
  - [▶️ Model Based Testing with XState | Path Generation with Context | Part 3](https://www.youtube.com/watch?v=9gQulfnG7HM)
- [▶️ Managing UI Complexity with Statecharts (playlist)](https://www.youtube.com/playlist?list=PLsVj0cy-DbErFraf3KeAUbzVl-OKyBZ0-) le 01/08/2020
- [▶️ XState Pizza Wizard!](https://www.youtube.com/watch?v=JauJhGTBFsc) par [Jack Herrington](https://github.com/jherr) le 22/07/2020
- [▶️ Declarative and manageable state management with XState](https://www.youtube.com/watch?v=jCbV5aELY6A) par [Daniel Lemay](https://github.com/dslemay) le 22/07/2020
- [▶️ Learning XState with Lauren](https://www.youtube.com/watch?v=h5H1ZmjMDE4) le 17/07/2020
- [▶️ The Actor Model | XState part 1](https://www.youtube.com/watch?v=4CLdNeetVHw) par [@bisvarup](https://bisvarup.me/) le 15/07/2020
  - [CodeSandbox example](https://codesandbox.io/s/ancient-framework-bvw61?file=/src/App.js)
- [▶️ Part 1: Tic-tac-toe - Let's build (using JavaScript, React, Cypress and XState)](https://www.youtube.com/watch?v=uVySNh6ud2w) par Dane Harnett le 28/06/2020
  - [▶️ Part 2](https://www.youtube.com/watch?v=LtqTNATLIlY)
  - [▶️ Part 3](https://www.youtube.com/watch?v=t5WU1oZeBQw)
- [▶️ How to add an XState machine conf to a project](https://www.youtube.com/watch?v=A0bLzjQdZPU) par [Diego Perez](https://www.youtube.com/channel/UCxr-10LjbO-CTiPRcCLyRyg) le 26/06/2020
- [▶️ Autocomplete, XState, and anything in between](https://www.youtube.com/watch?v=7CP-OUcUq2Q) par [Krzysztof Żuraw](https://krzysztofzuraw.com) le 24/06/2020
- [▶️ Creating a `useAutoSave` Hook - Part 5: Using XState](https://www.youtube.com/watch?v=JPgd1RG-rOk) par [Brooks Lybrand](https://twitter.com/BrooksLybrand) le 08/05/2020
  - [CodeSandbox](https://codesandbox.io/s/useautosavefinal-xhsyx?file=/src/useAutoSave-5.js)
- [▶️ Improving Application Predictability with XState](https://www.youtube.com/watch?v=MbS2TQj4Xsc) par [Sam Edwards](https://twitter.com/sjoedwards) le 29/04/2020
- [▶️ Webinar - Visualize Application State with XState in JavaScript](https://www.youtube.com/watch?v=GhHh_9I6CXQ) par Dani Akash le 02/04/2020
- [▶️ Drag & Drop State Machine! Learning XState with David](https://www.youtube.com/watch?v=osaszd2aU9U) on the [Keyframers](https://twitter.com/keyframers) le 06/03/2020 ![Stately member](/docs/stately.png)
  - [GitHub - Code](https://github.com/jherr/xstate-pizza-orderer)
- [▶️ How to Build a simple React App with XState](https://www.youtube.com/watch?v=g_2lt7bBwpk) par Tim Ermilov le 04/03/2020
- [▶️ Authentication statechart in XState](https://www.youtube.com/watch?v=lIge4KWq6Xc) par [Brooks Lybrand](https://twitter.com/BrooksLybrand) le 07/02/2020
- [▶️ Aplicaciones React usando XState](https://www.youtube.com/watch?v=9P3sLqSiswE) by Luis César Contreras le 21/01/2020
- [▶️ Improving state representation by using XState in React](https://www.youtube.com/watch?v=hG3UHNCUdzQ) par [Jon Major Condon](https://www.youtube.com/channel/UCQB-QsEnKCvJX4e_ms9XvHA) le 03/10/2019
- [▶️ Isaac && Zack Code Jam #2: State Machines and XState](https://www.youtube.com/watch?v=emAUbr0XHqg) le 03/10/2019
  - [▶️ Part 3](https://www.youtube.com/watch?v=R2vzzuUkjV0)
- [▶️ XState and State Machines in Vue](https://tallpad.com/series/xstate-misc/episode/1)
- [▶️ Standing on the Shoulders of Giants. Development with XState](https://www.youtube.com/watch?v=GuzcWkVrqLg) par Brad Woods le 11/09/2019
  - [Slides and more](https://www.atlassian.com/atlascamp/watch-sessions/2019/advanced-app-development/standing-on-the-shoulders-of-giants-development-with-xstate)
- [▶️ Infinitely Better UIs with Finite Automata (React Rally)](https://www.youtube.com/watch?v=VU1NKX6Qkxc) par [David Khourshid](https://github.com/statelyai) le 25/08/2017 ![Stately member](/docs/stately.png)

## Repositories

- [Une UI dans tous ses états avec XState (A UI in all its states with XState)](https://github.com/rbung/xstatePrez) par [Rodolphe Bung](https://github.com/rbung)
- [XState: Street Lights with Pedestrian Crossing using Vue.js](https://codesandbox.io/s/stoic-thompson-ktzrl?file=/src/App.vue) par [Kevin Warrington](https://github.com/dubbs)
- [CodeSandbox - XState Login & Sign Up Forms](https://codesandbox.io/s/xstate-login-sign-up-forms-yzzoc) par [Jamie Mason](https://github.com/JamieMason)
- [GitHub - a flipping cards game using XState](https://github.com/lednhatkhanh/xstate-flipping-cards-game) par [@lednhatkhanh](https://github.com/lednhatkhanh) le 21/04/2020
- [Tic-Tac-Toe with Crank, XState, and TypeScript](https://github.com/mwarger/tic-tac-toe-crank-xstate-typescript) par [@warger](https://github.com/mwarger) le 17/04/2020
- [GitHub - Autocomplete example with XState](https://github.com/krzysztofzuraw/xstate-autocomplete) par [@krzysztofzuraw](https://github.com/krzysztofzuraw) le 06/04/2020
- [Github - XState with React and Angular in Nx Workspace](https://github.com/nartc/nx-state-machine-todos-mvc) par [Chau Tran](https://nartc.me) le 08/03/2020
- [GitHub - XState Sample Kit](https://github.com/rjdestigter/xstate-sample-kit) par [@rjdestigter](https://github.com/rjdestigter) le 17/02/2020
  - [Playable demo](https://xstate-flipping-cards-game.now.sh/)
- [GitHub - a Markdown Editor in Vue.js and XState](https://github.com/sarahdayan/markdown-editor-vue-xstate) par [Sarah Dayan](https://github.com/sarahdayan) le 15/02/2020
  - [Live Demo](https://nifty-yalow-295db4.netlify.app/)
- [GitLab - TDDing XState](https://gitlab.com/danbunea/tdding-xstate) par Dan Bunea le 13/02/2020
- [Tips and tricks of using XState for UI development](https://github.com/farskid/xstate.tips) par [Farzad Yousefzadeh](https://github.com/farskid) le 24/01/2020 ![Stately member](/docs/stately.png)
  - [Link: XState.Tips](https://xstate.tips/)
- [GitHub - Cypress Real-World App](https://github.com/cypress-io/cypress-realworld-app) le 07/01/2020
- [GitHub - A Pac Man game, built with React, TypeScript, MobX, styled-components, and XState](https://github.com/stefanwille/pacman-react) par [Stefan Wille](https://github.com/stefanwille) le 21/12/2019
  - [Playable demo](https://pacman-react.netlify.app/)
- [GitHub - a small React, XState and Framer Motion demo](https://github.com/tanem/state-machines-in-react) par [@tanem](https://github.com/tanem) le 29/09/2019
- [GitHub - Practical examples of statechart-based solutions with XState](https://github.com/DevanB/xstate-examples) par [@DevanB](https://github.com/DevanB) le 07/09/2019
- [CodePen - XState Vue Login Page](https://codepen.io/ryanzola/pen/PMwoqe) par [Ryan Zola](https://codepen.io/ryanzola) le 19/07/2019
